const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const game_contents = sequelize.define(
    'game_contents',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

launch_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"UPLOAD_HTML",


"REDIRECT_URL"

        ],

      },

redirect_url: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  game_contents.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity





























//end loop



    db.game_contents.belongsTo(db.products, {
      as: 'product',
      foreignKey: {
        name: 'productId',
      },
      constraints: false,
    });



    db.game_contents.hasMany(db.file, {
      as: 'html_bundle',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.game_contents.getTableName(),
        belongsToColumn: 'html_bundle',
      },
    });


    db.game_contents.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.game_contents.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return game_contents;
};


